#define BEEP_TIMER TIM17
#define SNBR 100

u8 Bsin_t[SNBR];
u32 Sin_step;

inline void generate_sound_table(void)
{
 for(int i=0; i < SNBR; i++) Bsin_t[i] = (u8)(__iar_sin_small(PI/2*i/SNBR)*0xff);
}

void beep(volatile u32* beep_tim, int frq=5500, int time_ms = 500)
{
 BEEP_TIMER->PSC   = 0;
 BEEP_TIMER->ARR   = (SYSTEM_FRQ/8/frq);
 BEEP_TIMER->CCR1  = 0;
 BEEP_TIMER->CCMR1 = pwm1;
 BEEP_TIMER->CCER  = TIM_CCER_CC1E;
 BEEP_TIMER->BDTR  = TIM_BDTR_MOE;
 BEEP_TIMER->EGR   = TIM_EGR_UG;
 BEEP_TIMER->CR1   = TIM_CR1_CEN;

 if(time_ms < SNBR) time_ms = SNBR;
 Sin_step = time_ms/SNBR;

 *beep_tim = time_ms;
}

static inline void beep_processing(const u32 beep_tim)
{
 static u32 tcnt;
 static u32 cnt;

 if(!beep_tim)
 {
  BEEP_TIMER->CCMR1 = force_active;
  BEEP_TIMER->CR1   = 0;

  tcnt = 0;
  cnt = Sin_step;
 }
 else
 {
  if(tcnt < SNBR)
  {
   if(cnt < Sin_step-1) cnt++;
   else
   {
    BEEP_TIMER->CCR1 = (u32)Bsin_t[tcnt] * BEEP_TIMER->ARR >> 8;

    cnt = 0;
    tcnt++;
   }
  }
 }
}

