#pragma section=".intvec"
#pragma section=".chksum_mem"

const __no_init u32 chksum @".chksum_mem";
extern u32 __ICFEDIT_region_ROM_start__;

u32 calc_flash_crc(void)
{
 u32* begin = (u32*)&__ICFEDIT_region_ROM_start__;
 u32* end   = (u32*)&chksum;
 u32* pt;

 u32 tmp     = RCC->AHBENR;
 tmp        |= RCC_AHBENR_CRCEN;
 RCC->AHBENR = tmp;

 CRC->CR = CRC_CR_RESET;

 for(pt = begin; pt < end; pt++) CRC->DR = *pt;

 u32 tmp2 = CRC->DR;

 tmp &= ~RCC_AHBENR_CRCEN;
 RCC->AHBENR = tmp;

 return tmp2;
}

bool get_flash_crc(void)
{
 if(calc_flash_crc() == chksum)return true;

 return false;
}

void set_flash_crc(void)
{
 if(chksum == (u32)-1)
 {
  u32 tmp = calc_flash_crc();

  __disable_interrupt();
  FLASH_Unlock();

  while(FLASH_ProgramWord((uint32_t)&chksum, tmp) ==FLASH_BUSY) continue;

  FLASH_Lock();
  __enable_interrupt();
 }
}


