#define TIM_NUM 7

volatile u32 Tim[TIM_NUM];
#define MSR_TIM    Tim[0]
#define SNSR_TIM   Tim[1]
#define BEEP_TIM   Tim[2]
#define LED_TIM    Tim[3]
#define ERR_TIM    Tim[4]
#define TMR_TIM    Tim[5]
#define BTD_TIM    Tim[5]

volatile bool Iwdg_systick;

extern "C"
{
 void SysTick_Handler()
 {
  for(int i=0;i<TIM_NUM;i++) if(Tim[i])Tim[i]--;

  beep_processing(BEEP_TIM);

  Iwdg_systick = true;
 }

//-----------------------------------

 void HardFault_Handler()
 {
  scr_off();

  while(1)__no_operation();
 }

 void NMI_Handler()
 {
  scr_off();

  NVIC_SystemReset();
 }

 void Default_Handler()
 {
  scr_off();

  while(1)__no_operation();
 }
}



//   Reset_Handler                  ; Reset Handler
//
//   NMI_Handler                    ; NMI Handler
//   HardFault_Handler              ; Hard Fault Handler
//   PendSV_Handler                 ; PendSV Handler
//   SysTick_Handler                ; SysTick Handler
//
//  ; External Interrupts
//   WWDG_IRQHandler                ; Window Watchdog
//   PVD_IRQHandler                 ; PVD through EXTI Line detect
//   RTC_IRQHandler                 ; RTC through EXTI Line
//   FLASH_IRQHandler               ; FLASH
//   RCC_IRQHandler                 ; RCC
//   EXTI0_1_IRQHandler             ; EXTI Line 0 and 1
//   EXTI2_3_IRQHandler             ; EXTI Line 2 and 3
//   EXTI4_MDEV_IRQHandler            ; EXTI Line 4 to MDEV
//   TS_IRQHandler                  ; TS
//   DMA1_Channel1_IRQHandler       ; DMA1 Channel 1
//   DMA1_Channel2_3_IRQHandler     ; DMA1 Channel 2 and Channel 3
//   DMA1_Channel4_5_IRQHandler     ; DMA1 Channel 4 and Channel 5
//   ADC1_COMP_IRQHandler           ; ADC1, COMP1 and COMP2
//   TIM1_BRK_UP_TRG_COM_IRQHandler ; TIM1 Break, Update, Trigger and Commutation
//   TIM1_CC_IRQHandler             ; TIM1 Capture Compare
//   TIM2_IRQHandler                ; TIM2
//   TIM3_IRQHandler                ; TIM3
//   TIM6_DAC_IRQHandler            ; TIM6 and DAC
//   0                              ; Reserved
//   TIM14_IRQHandler               ; TIM14
//   TIMMDEV_IRQHandler               ; TIMMDEV
//   TIM16_IRQHandler               ; TIM16
//   TIM17_IRQHandler               ; TIM17
//   I2C1_IRQHandler                ; I2C1
//   I2C2_IRQHandler                ; I2C2
//   SPI1_IRQHandler                ; SPI1
//   SPI2_IRQHandler                ; SPI2
//   USART1_IRQHandler              ; USART1
//   USART2_IRQHandler              ; USART2
//   0                              ; Reserved
//   CEC_IRQHandler                 ; CEC
//   0                              ; Reserved

