#include <kb.h>

/*
 MODER  00->input, 01->output, 10->AF, 11->analog
 OTYPER 0->PP, 1->OD
 PUPDR  00-> nopull, 01-> pullup, 10-> pulldn

*/

void btn_init(void)
{
 //        
 for(int i=0;i<sizeof(GPIO_btns)/sizeof(GDF) ;i++)
 {
  GPIO_btns[i].GPIOx->MODER &= ~(3 << GPIO_btns[i].shift*2); //input

  GPIO_btns[i].GPIOx->PUPDR &= ~(3 << GPIO_btns[i].shift*2); //nopull
  GPIO_btns[i].GPIOx->PUPDR |=   1 << GPIO_btns[i].shift*2;  //pullup
 }
}

//  
//   enum_ 
// true       
static inline bool btn_scan(void)
{
 static u8 count[BNUM][3];
 bool retval = false;

  //    
 for(int i=0;i<BNUM;i++)
 {
  int pos = i;

  //     
  volatile bool input = (GPIO_btns[i].GPIOx->IDR & (1<<GPIO_btns[i].shift));

  // 
  key_coll(input, count, (keyst*)btn, pos);

  if(btn[pos]!= rls) retval = true;
 }

 return retval;
}

static inline void key_coll(const bool input, u8 count[][3], keyst btn[], const u8 pos)
{
 //  
 if (!input)
 {
  if(count[pos][0]>LP)
  {
   count[pos][0]=0;

   if(btn[pos]==rls) btn[pos]=prs;

   if(count[pos][1]>LH)
   {
    btn[pos]=hold;
    count[pos][1]=0;
   }
   else
    count[pos][1]++;
  }
  else
   count[pos][0]++;

  count[pos][2]=LR;
 }
 else //   ,       
 {
  if(count[pos][2])
   count[pos][2]--;
  else
  {
   count[pos][0]=0;
   count[pos][1]=0;

   btn[pos]=rls;
  }
 }
}

//________________________________________________
//         true
bool kb_input(u16 *value, u16 min_value, u16 max_value, u16 step, u32 *timer, bool *btn_trg)
{
 static bool btp0,btp1;
 bool retval = false;

 if(btn[0]!=rls && btn[1]!=rls)
 {
  btp1=btp0=0;
  retval   = true;
 }
 else if(btn[0]==prs && !*btn_trg)
 {
  *btn_trg=1;
  btp0 = 1;
 }
 else if(btn[1]==prs && !*btn_trg)
 {
  *btn_trg=1;
  btp1 = 1;
 }
 else if(btn[0]==hold)
 {
  btp1=btp0=0;
  if(!(*timer))
  {
   *timer=1000;
   if(*value>min_value+step)*value-=step;
   else *value=min_value;
  }
 }
 else if(btn[1]==hold)
 {
  btp1=btp0=0;
  if(!(*timer))
  {
   *timer=1000;
   if(*value<max_value-step)*value+=step;
   else *value=max_value;
  }
 }

 if(!(*btn_trg))
 {
  if(btp0)
  {
   btp1=btp0=0;
   if(*value>min_value+step)*value-=step;
   else *value=min_value;
  }
  else if(btp1)
  {
   btp1=btp0=0;
   if(*value<max_value-step)*value+=step;
   else *value=max_value;
  }
 }

 return retval;
}

