
extern void beep(volatile u32* beep_tim, int frq, int time_ms);
extern volatile u32 Tim[7];

void scr_on(void) { TIM1->BDTR = TIM_BDTR_MOE; }

void scr_off(void){ TIM1->BDTR = 0; }

bool check_recal_pin(void)
{
 int k=0;

 for(int i=0; i<0xff; i++)
  if(GPIOA->IDR & GPIO_Pin_10) k++;
  else if(k) k--;

  if(k > 0xff - 0xff/3) return false;
  else return true;
}

/*
         
*/
bool boiling_detector(const int T, bool *reset)
{
 #define VDIFF 15

 const int n_vdiff = ((T_MAX - T_MIN)*VDIFF<<8)/HT_TO;

 static bool start_trg;
 static u32 cntdn;
 static u32 init_cntdn;
 static int T_max;

 bool retval = false;


 if(start_trg == false || *reset == true)
 {
  start_trg = true;
  *reset = false;

  init_cntdn = VDIFF*2;
  cntdn = VDIFF;
  T_max = T;
 }
 else
 {
  if(init_cntdn) init_cntdn--;
  else
  {
   bool tvd_trg = false;

   if(T > T_max)
   {
    cntdn = VDIFF;

    T_max = T;

    tvd_trg = true;

//    beep(&Tim[2],1500,200);
   }
   else
   {
    if(cntdn)cntdn--;
    else
    {
     retval = true;

     beep(&Tim[2],8000,200);
    }
   }

   //      VDIFF     10   
   static u32 tvd_cnt;
   static int k;

   tvd_cnt++;
   if(tvd_trg==true) k++;

   if(tvd_cnt >= VDIFF)
   {
    tvd_cnt = 0;

    //    VDIFF 
    if(k<<8 < n_vdiff)
    {
     retval = true;

     beep(&Tim[2],500,200);
    }

    k = 0;
   }
  }
 }

 if(retval==true) start_trg = false;

 return retval;
}

