

 void cfg_rcc(void)
 {
  RCC->AHBENR  |= RCC_AHBENR_GPIOAEN | RCC_AHBENR_GPIOBEN | RCC_AHBENR_GPIOFEN | RCC_AHBENR_DMA1EN;

  RCC->APB1ENR |= RCC_APB1ENR_TIM2EN;
  RCC->APB2ENR |= RCC_APB2ENR_TIM1EN | RCC_APB2ENR_TIM17EN | RCC_APB2ENR_ADC1EN;

  RCC->CFGR    |= 7<<8; //APB prescaler 16
 }

 void cfg_gpio(void)
 {
  GPIO_InitTypeDef GIS;

  GIS.GPIO_Speed = GPIO_Speed_2MHz;

 //PF1,PF0 - reset pullup
  GIS.GPIO_Pin   = GPIO_Pin_0|GPIO_Pin_1;
  GIS.GPIO_Mode  = GPIO_Mode_IN;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_UP;

  GPIO_Init(GPIOF, &GIS);

 //PA0, PA1, PA2 - AF tim2,      
  GIS.GPIO_Pin   = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2;
  GIS.GPIO_Mode  = GPIO_Mode_AF;
  GIS.GPIO_OType = GPIO_OType_PP;
  GIS.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOA, &GIS);

  GPIO_PinAFConfig(GPIOA, GPIO_PinSource0, GPIO_AF_2);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource1, GPIO_AF_2);
  GPIO_PinAFConfig(GPIOA, GPIO_PinSource2, GPIO_AF_2);

  //PA3

  //PA4
  GIS.GPIO_Pin   = GPIO_Pin_4;
  GIS.GPIO_Mode  = GPIO_Mode_OUT;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOA, &GIS);


  //PA5, PA6 -      Vdd
  GIS.GPIO_Pin   = GPIO_Pin_5;//|GPIO_Pin_6;
  GIS.GPIO_Mode  = GPIO_Mode_AN;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_UP;

  GPIO_Init(GPIOA, &GIS);

  //PA6 -     Vdd
  GIS.GPIO_Pin   = GPIO_Pin_6;
  GIS.GPIO_Mode  = GPIO_Mode_IN;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_UP;

  GPIO_Init(GPIOA, &GIS);

  //PA7 - AF tim17
  GIS.GPIO_Pin   = GPIO_Pin_7;
  GIS.GPIO_Mode  = GPIO_Mode_AF;
  GIS.GPIO_OType = GPIO_OType_PP;
  GIS.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOA, &GIS);

  GPIO_PinAFConfig(GPIOA, GPIO_PinSource7, GPIO_AF_5);

  //PB1 -     Vdd
  GIS.GPIO_Pin   = GPIO_Pin_1;
  GIS.GPIO_Mode  = GPIO_Mode_IN;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_UP;

  GPIO_Init(GPIOB, &GIS);

  //PA9 - AF tim1,  
  GIS.GPIO_Pin   = GPIO_Pin_9;
  GIS.GPIO_Mode  = GPIO_Mode_AF;
  GIS.GPIO_OType = GPIO_OType_PP;
  GIS.GPIO_PuPd  = GPIO_PuPd_NOPULL;

  GPIO_Init(GPIOA, &GIS);

  GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_2);

  //PA10 -      Vdd
  GIS.GPIO_Pin   = GPIO_Pin_10;
  GIS.GPIO_Mode  = GPIO_Mode_IN;
  GIS.GPIO_OType = GPIO_OType_OD;
  GIS.GPIO_PuPd  = GPIO_PuPd_UP;

  GPIO_Init(GPIOA, &GIS);
 }

 // 1   0,5ms (20   )
 void cfg_t1(void)
 {
  TIM1->ARR   = 500;
  TIM1->CCR2  = 1;
  TIM1->CCMR1 = pwm1 <<8;
  TIM1->CCER  = TIM_CCER_CC2E;
  TIM1->BDTR  = bin(11)<<8; //lock_2
  TIM1->EGR   = TIM_EGR_UG;
  TIM1->CR1   = TIM_CR1_CEN;
 }


 void cfg_systic()
 {
  SysTick->LOAD  = SYSTEM_FRQ/T_SEC-1;
  SysTick->VAL   = 0;
  SysTick->CTRL  = SysTick_CTRL_CLKSOURCE_Msk|SysTick_CTRL_TICKINT_Msk|SysTick_CTRL_ENABLE_Msk;
 }

 void cfg_iwdg()
 {
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
  IWDG_SetPrescaler(IWDG_Prescaler_256);
  IWDG_SetReload((u32)8E4/256);//2c
  IWDG_ReloadCounter();
  IWDG_Enable();
 }

//0x9f vdda_off parity_on, 0xdf vdda_off, 0xbf ram parity checking on
FLASH_Status FLASH_OB_UBC(uint8_t input_val = 0xbf)
{
  FLASH_Status status = FLASH_COMPLETE;

  if((OB->USER & 0xff) != input_val)
  {
   /* Wait for last operation to be completed */
   status = FLASH_WaitForLastOperation(FLASH_ER_PRG_TIMEOUT);

   if(status == FLASH_COMPLETE)
   {
    __disable_interrupt();
    FLASH_Unlock();
    FLASH_OB_Unlock();

    uint8_t tmp_mss[sizeof(*OB)/sizeof(uint16_t)];
    uint16_t *pt = (uint16_t *)OB;

    for(int i=0; i<sizeof(*OB)/sizeof(uint16_t);i++) tmp_mss[i] = uint8_t(*pt++);

     FLASH->CR |= FLASH_CR_OPTER;
     FLASH->CR |= FLASH_CR_STRT;

     while((FLASH_WaitForLastOperation(FLASH_ER_PRG_TIMEOUT)==FLASH_BUSY))__no_operation();

     FLASH->CR &= ~FLASH_CR_OPTER;
     FLASH->CR |= FLASH_CR_OPTPG;

     OB->USER = input_val;
     while((FLASH_WaitForLastOperation(FLASH_ER_PRG_TIMEOUT)==FLASH_BUSY))__no_operation();

     pt = (uint16_t *)OB;

     for(int i=0; i<sizeof(*OB)/sizeof(uint16_t);i++)
     {
      *(pt+i) = tmp_mss[i];

      if(i==((uint16_t *)&OB->USER -(uint16_t *)OB))i++;

      while((FLASH_WaitForLastOperation(FLASH_ER_PRG_TIMEOUT)==FLASH_BUSY))__no_operation();
     }

     /* Wait for last operation to be completed */
     status = FLASH_WaitForLastOperation(FLASH_ER_PRG_TIMEOUT);

     if(status != FLASH_TIMEOUT)
     {
       /* if the program operation is completed, disable the OPTPG Bit */
       FLASH->CR &= ~FLASH_CR_OPTPG;
       FLASH_OB_Lock();
       FLASH_Lock();

       FLASH_OB_Launch();
     }
   }
  }
  /* Return the Option Byte program Status */
  return status;
}









