#include <sb_works.h>

#define INA  (GPIO_def+i)->GPIOx, (GPIO_def+i)->shift_a
#define OUTA (GPIO_def+i)->GPIOx, (GPIO_def+i)->shift_a,(bool)
#define OUTB (GPIO_def+i)->GPIOxc,(GPIO_def+i)->shift_b,(bool)

//        
int sb_lines[BNUM];

//  
u32 L_IDR (GPIO_TypeDef *GPIOx, u16 shift)
{
 return (u32)(GPIOx->IDR & 1<<shift);
}

//true->>output mode, false->> input mode
void L_DDR (GPIO_TypeDef *GPIOx, u16 shift, bool x)
{
 GPIOx->MODER &= ~(3<<2*shift);

 if(x == true) GPIOx->MODER |= 1<<2*shift;
}

//true -> OD, false -> PP
void L_OTR (GPIO_TypeDef *GPIOx, u16 shift, bool x)
{
 (x)?(GPIOx->OTYPER |= 1<<shift):(GPIOx->OTYPER &= ~(1<<shift));
}

//true->> pinup, false->> pindn
void L_ODR (GPIO_TypeDef *GPIOx, u16 shift, bool x)
{
 (x)?(GPIOx->BSRR  = 1<<shift):(GPIOx->BRR = 1<<shift);
}

void ts_discharge(GDF pst)
{
 L_OTR (pst.GPIOx, pst.shift_a, 0); //PP
 L_DDR (pst.GPIOx, pst.shift_a, 1); //cfg as output
 L_ODR (pst.GPIOx, pst.shift_a, 0); //switch to gnd

 L_OTR (pst.GPIOxc, pst.shift_b, 1); //OD
 L_DDR (pst.GPIOxc, pst.shift_b, 1); //cfg as output
 L_ODR (pst.GPIOxc, pst.shift_b, 0); //switch to gnd
}

void ts_pause(void)
{
 for(volatile u32 k=0xff; k; k--) continue;
}

//       
void scan_lines(int sb_lines[])
{
 ts_discharge(GPIO_def[0]);

 for(int i=0;i<BNUM;i++)
 {
  //   
  sb_lines[i] = 0;

  //    
  ts_discharge(GPIO_def[i]);

  // 
  ts_pause();

  //     
  L_DDR(OUTA 0);
  L_ODR(OUTA 1);

  int cnt = 0;
  //    
  do
  {
   sb_lines[i]++;

   //    
   L_ODR(OUTB 1);

   // 
   L_DDR(OUTA 1);

   //       
   ts_pause();

   //   
   L_DDR(OUTA 0);
   //    
   L_ODR(OUTB 0);

   //    
   ts_pause();

   //      1  
   if(L_IDR(INA) !=0) cnt++;
   else cnt = 0;
  }
  //          
  while (cnt<2 && sb_lines[i]<(u16)-1);

  //    
  ts_discharge(GPIO_def[i]);
 }
}

void sensor_processing(int sb_lines[], enum keyst kline[])
{
 #define PAD_TRSH (7*256/100)
 #define PCNV 60  //       

 static bool init_trg;
 static int prev_val  [BNUM];
 static int prs_cntdn [BNUM];
 static int base_val  [BNUM];
 static int prs_cnt   [BNUM];

 for(int i=0;i<BNUM;i++)
 {
  if(init_trg == true)
  {
   //    
   int dN = prev_val[i] - sb_lines[i];

   //  ,  
   if(dN < -1 || dN > 1)
   {
    prs_cntdn[i] = PCNV;
    prs_cnt  [i] = 0;
   }
   else  //  ,  
   {
    //        
    //  0,25    3     
    if(prs_cntdn[i])
    {
     if(sb_lines[i] < base_val[i] - (base_val[i]*PAD_TRSH>>8))
     {
      if(prs_cnt[i] > 5) kline[i] = prs;
      else prs_cnt[i]++;
     }
     else
     {
      if(prs_cnt[i]) prs_cnt[i]--;
      else kline[i] = rls;
     }

     prs_cntdn[i]--;
    }
    //      3     
    //     
    else
    {
     base_val[i] = sb_lines[i];
     kline[i] = rls;
    }
   }
  }
  //          
  else base_val[i] = sb_lines[i];

  prev_val[i] = sb_lines[i];
 }

 init_trg = true;
}



