
#define TS_CAL_30  (*(u16*)0x1FFFF7B8)
#define TS_CAL_110 (*(u16*)0x1FFFF7C2)
#define VREF_CAL   (*(u16*)0x1FFFF7BA)

#define VDD_BASE 3300

//#define ADC_IN_6 conversion_result[3]
#define ADC_IN_5 conversion_result[0]
#define ADC_TS   conversion_result[1]
#define ADC_VREF conversion_result[2]


//u32 conversion_result[4];
u32 conversion_result[3];
const u32 SLOPE = ((u32)(110-30)<<10)/(TS_CAL_30-TS_CAL_110); //~190

void dma_adc_config(void)
{
 DMA1_Channel1->CPAR = u32(&ADC1->DR);
 DMA1_Channel1->CMAR = (uint32_t)conversion_result;
 DMA1_Channel1->CNDTR = sizeof(conversion_result)/sizeof(conversion_result[0]);
 DMA1_Channel1->CCR  = DMA_CCR_MINC | DMA_CCR_CIRC | DMA_CCR_MSIZE_1 | DMA_CCR_PSIZE_1;
 DMA1_Channel1->CCR |= DMA_CCR_EN;
}

void adc_config (void)
{
 ADC1->CFGR1 = ADC_CFGR1_AUTOFF | ADC_CFGR1_WAIT | ADC_CFGR1_DMAEN | ADC_CFGR1_DMACFG;

 ADC1->CFGR2 = 1UL<<30; //PCLK/2,  PCLK  /16
// ADC1->CHSELR = 1<<17 | 1<<16 | 1<<6 | 1<<5;
  ADC1->CHSELR = 1<<17 | 1<<16 | 1<<5;
 ADC1->SMPR = 0;//7; //240 cycles,      
 ADC->CCR = ADC_CCR_VREFEN|ADC_CCR_TSEN;
}

void calibrate_adc(void)
{
 // ADC
 ADC1->CR = ADC_CR_ADSTP;
 while((ADC1->CR & ADC_CR_ADSTP)!=0)continue;

 ADC1->CFGR1 = 0;

 // ADC
 if((ADC1->CR & ADC_CR_ADEN) !=0)
 {
  ADC1->CR = ADC_CR_ADDIS;
  while((ADC1->CR & ADC_CR_ADEN) !=0) continue;
 }

 // dma     
 ADC1->CFGR1 &= ~ADC_CFGR1_DMAEN;

 // 
 ADC1->CR = ADC_CR_ADCAL;
 //  
 while((ADC1->CR & ADC_CR_ADCAL)!=0) continue;

 //  
 ADC1->ISR = ADC_ISR_ADRDY;

 // 
 ADC1->CR |= ADC_CR_ADEN;

 // 
 while((ADC1->ISR & ADC_ISR_ADRDY)==0) continue;

 ADC1->CFGR1 = ADC_CFGR1_AUTOFF | ADC_CFGR1_WAIT | ADC_CFGR1_DMAEN | ADC_CFGR1_DMACFG;
}

void do_conversion(void)
{
 calibrate_adc();
 ADC1->CR = ADC_CR_ADSTART;

 while((DMA1->ISR & DMA_ISR_TCIF1)==0)continue;
 DMA1->IFCR = DMA_IFCR_CGIF1;
}

void calc_kVdd(u32 *k_Vdd)
{
 *k_Vdd = ((u32)VREF_CAL<<10)/ADC_VREF;
}

void calc_ambient(int *ambient_C, const u32 k_Vdd)
{
 u32 tmp = ADC_TS*k_Vdd;

 *ambient_C = int((((s64)TS_CAL_30<<10)-tmp)*SLOPE >>20) + 30;
}

void calc_Vin(u32 *Vin, const u32 k_Vdd)
{
// u64 tmp = ADC_IN_5 + ADC_IN_6 >>1;
 u64 tmp = ADC_IN_5;

 *Vin = tmp * k_Vdd * VDD_BASE >>12 >>10;
}

void Vin_2_t(int *t, const int Vin, const NIS Dval, const bool recal_trg)
{
// #define DCTV 2100 // uV  C
// #define DCTV_MPL ((1<<12)*1000/DCTV)>>12  // 1950/4096/1000 ~= 1/2100

 static bool init_trg = false;
 static int DCTV;
 static int DCTV_MPL;

 if(init_trg == false)
 {
  init_trg = true;

  //  
  if(recal_trg == true) DCTV = 2100;
  // ,        100   
  else                  DCTV = (Dval.V_LTS*1000 - Dval.V_100C*1000)/(100 - Dval.C_LTS);

  DCTV_MPL = (1<<12)*1000/DCTV;
 }

 *t = Dval.C_LTS + ((Dval.V_LTS - Vin)*DCTV_MPL >>12);
}